<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>pam_pkcs11: base64.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">pam_pkcs11
   &#160;<span id="projectnumber">0.6.11</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',false,false,'search.php','Search');
});
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_fdedb0aba14d44ce9d99bc100e026e6a.html">common</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">base64.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><a href="base64_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:a0d1891009ac4707fec0e39ce5661c389"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="base64_8h.html#a0d1891009ac4707fec0e39ce5661c389">BASE64_EXTERN</a>&#160;&#160;&#160;extern</td></tr>
<tr class="separator:a0d1891009ac4707fec0e39ce5661c389"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a2a0b86fe0ae0744ee21e01241143ddeb"><td class="memItemLeft" align="right" valign="top"><a class="el" href="base64_8h.html#a0d1891009ac4707fec0e39ce5661c389">BASE64_EXTERN</a> int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="base64_8h.html#a2a0b86fe0ae0744ee21e01241143ddeb">base64_encode</a> (const unsigned char *in, size_t len, unsigned char *out, size_t *outlen)</td></tr>
<tr class="memdesc:a2a0b86fe0ae0744ee21e01241143ddeb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Encode byte array into a base64 string.  <a href="#a2a0b86fe0ae0744ee21e01241143ddeb">More...</a><br /></td></tr>
<tr class="separator:a2a0b86fe0ae0744ee21e01241143ddeb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a46341729fc3f2f61de527dd227ece930"><td class="memItemLeft" align="right" valign="top"><a class="el" href="base64_8h.html#a0d1891009ac4707fec0e39ce5661c389">BASE64_EXTERN</a> int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="base64_8h.html#a46341729fc3f2f61de527dd227ece930">base64_decode</a> (const char *in, unsigned char *out, size_t outlen)</td></tr>
<tr class="memdesc:a46341729fc3f2f61de527dd227ece930"><td class="mdescLeft">&#160;</td><td class="mdescRight">Decode a base64 string into a byte array.  <a href="#a46341729fc3f2f61de527dd227ece930">More...</a><br /></td></tr>
<tr class="separator:a46341729fc3f2f61de527dd227ece930"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Macro Definition Documentation</h2>
<a id="a0d1891009ac4707fec0e39ce5661c389"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0d1891009ac4707fec0e39ce5661c389">&#9670;&nbsp;</a></span>BASE64_EXTERN</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define BASE64_EXTERN&#160;&#160;&#160;extern</td>
        </tr>
      </table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="base64_8h_source.html#l00024">24</a> of file <a class="el" href="base64_8h_source.html">base64.h</a>.</p>

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a id="a46341729fc3f2f61de527dd227ece930"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a46341729fc3f2f61de527dd227ece930">&#9670;&nbsp;</a></span>base64_decode()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="base64_8h.html#a0d1891009ac4707fec0e39ce5661c389">BASE64_EXTERN</a> int base64_decode </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned char *&#160;</td>
          <td class="paramname"><em>out</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>outlen</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Decode a base64 string into a byte array. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>Input string data </td></tr>
    <tr><td class="paramname">out</td><td>Pointer to pre-allocated buffer space </td></tr>
    <tr><td class="paramname">outlen</td><td>Size of buffer </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Length of converted byte array, or -1 on error </dd></dl>

</div>
</div>
<a id="a2a0b86fe0ae0744ee21e01241143ddeb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2a0b86fe0ae0744ee21e01241143ddeb">&#9670;&nbsp;</a></span>base64_encode()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="base64_8h.html#a0d1891009ac4707fec0e39ce5661c389">BASE64_EXTERN</a> int base64_encode </td>
          <td>(</td>
          <td class="paramtype">const unsigned char *&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>len</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned char *&#160;</td>
          <td class="paramname"><em>out</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t *&#160;</td>
          <td class="paramname"><em>outlen</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Encode byte array into a base64 string. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>Pointer to byte array </td></tr>
    <tr><td class="paramname">len</td><td>lenght of input data </td></tr>
    <tr><td class="paramname">out</td><td>Pointer to preallocated buffer space </td></tr>
    <tr><td class="paramname">outlen</td><td>Size of buffer </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>0 on sucess, -1 on error </dd></dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed May 22 2019 12:09:34 for pam_pkcs11 by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
